// TCPserver.cpp : Defines the entry point for the console application.
#include "stdafx.h"
#include <stdio.h>
#include "winsock2.h"
#include <memory.h>

#define VELKOST 512
#define PORT 7777

void main() 
{

  //----------------------
  // Initialize Winsock
  WSADATA wsaData;
  int iResult = WSAStartup(MAKEWORD(2,2), &wsaData);
  if (iResult != NO_ERROR)
    printf("Error at WSAStartup()\n");

  //----------------------
  // Create a SOCKET for listening for
  // incoming connection requests.
    char recvbuf[VELKOST];
	char sendbuf[VELKOST];
	int recvbuflen = VELKOST;

  SOCKET ListenSocket;
  ListenSocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
  if (ListenSocket == INVALID_SOCKET) {
    printf("Soket se nezriesil: %ld\n", WSAGetLastError());
    WSACleanup();
    return;
  }

  //----------------------
  // The sockaddr_in structure specifies the address family,
  // IP address, and port for the socket that is being bound.
  sockaddr_in service;
  service.sin_family = AF_INET;
  service.sin_addr.s_addr = inet_addr("127.0.0.1");
  service.sin_port = htons(PORT);

  if (bind( ListenSocket,(SOCKADDR*) &service, sizeof(service)) == SOCKET_ERROR) 
  {
    printf("IP abo Portik nebavi!!!!\n");
    closesocket(ListenSocket);
    return;
  }

  //----------------------
  if (listen( ListenSocket, 1 ) == SOCKET_ERROR) 
  {
    printf("Uz neslucham\n");
    closesocket(ListenSocket);
    WSACleanup();
    //return 1;
  }

  //----------------------
  // Create a SOCKET for accepting incoming requests.
  SOCKET AcceptSocket;
  printf("Waiting for client to connect...\n");
  //----------------------
  // Accept the connection.

 int static i = 5;
  while (i) 
  {
  AcceptSocket = accept( ListenSocket, NULL, NULL );
  if (AcceptSocket == INVALID_SOCKET) 
  {
    printf("Dakto se xcel pripojic ale uz nechce: %d\n", WSAGetLastError());
    closesocket(ListenSocket);
    WSACleanup();
   // return 1;
  } 
	
	printf("Klient sa pripojil.\n");
	iResult = recv(AcceptSocket, recvbuf, 512, 0);
       if ( iResult > 0 )
	   {	
			recvbuf[iResult] = '\0';
            printf("Prijatych bolo %d bytov v retazci: %s \n", iResult,recvbuf);
			memset(sendbuf,0,sizeof(sendbuf));
			//otocenie retazca
			for(int ii = 0; ii < iResult; ii++)
				sendbuf[iResult - 1 - ii] = recvbuf[ii];
			//posle otoceny retazec
			iResult = send(AcceptSocket,sendbuf,sizeof(sendbuf),0);
			if (iResult<0)
			{
				printf("daco nebavi z posielanim \n");
				closesocket(AcceptSocket);

			}
			closesocket(AcceptSocket);
	   }	
       else
	   {
            printf("recv failed: %d\n", WSAGetLastError());
			closesocket(AcceptSocket);
	   }
   	  i--;
   }
  closesocket(ListenSocket);
  WSACleanup();
  return;
}
