// TCPClient.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <winsock2.h>
#include <stdio.h>
#include <stdlib.h>


#define DEFAULT_BUFLEN 512
#define DEFAULT_PORT 27222

void main(int argc, char *argv[] ) 
{
	//test poctu argumentov
	if( argc != 4  )
	{	
		printf("nesedi pocet argumentov\n");
		printf("zadaj :  TCPClient IP_Adresu Port Spravu");
		exit(1);
	};

    // definicia premennych.
    int iResult;		//vysledky funkcii
    WSADATA wsaData;

    SOCKET ConnectSocket;
    struct sockaddr_in clientService; 

    int recvbuflen = DEFAULT_BUFLEN;
//    char *sendbuf = "posielam hello word";
    char recvbuf[DEFAULT_BUFLEN] = "";

    //----------------------
    // Initialize Winsock
    iResult = WSAStartup(MAKEWORD(2,2), &wsaData);
    if (iResult != NO_ERROR) 
	{
        printf("WSAStartup failed with error: %d\n", iResult);
       exit(1);
    }

    //----------------------
    // Create a SOCKET for connecting to server
    ConnectSocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    if (ConnectSocket == -1) 
	{
        printf("socket failed with error: %ld\n", WSAGetLastError());
        WSACleanup();
		exit(1);
    }

    //----------------------
    clientService.sin_family = AF_INET;
    clientService.sin_addr.s_addr = inet_addr( argv[1] );
    clientService.sin_port = htons( atoi(argv[2]) );

    //----------------------
    // Connect to server.
    iResult = connect( ConnectSocket, (SOCKADDR*) &clientService, sizeof(clientService) );
    if (iResult == SOCKET_ERROR)
	{
        printf( "connect failed with error: %d\n", WSAGetLastError() );
        closesocket(ConnectSocket);
        WSACleanup();
		exit(1);
	}
    iResult = send( ConnectSocket, argv[3],(int)strlen(argv[3]), 0 );
    if (iResult == SOCKET_ERROR)
	{
        printf("send() - Nepodarilo sa poslat data: %d\n", WSAGetLastError());
        closesocket(ConnectSocket);
        WSACleanup();
		exit(1);
    }
    printf("Bolo poslanych : %d bytov\n", iResult);

	iResult = recv( ConnectSocket, recvbuf,100, 0 );
    if (iResult == SOCKET_ERROR) 
	{
        printf("recv() - Nepodarilo sa prijat data a nastala chyba: %d\n", WSAGetLastError());
        closesocket(ConnectSocket);
        WSACleanup();
		exit(1);
    }

	printf("Bol prijaty otoceny retazec: %s\n", recvbuf);
	//vycistenie
	//uzavrie komunikacny socket
    closesocket(ConnectSocket);
    WSACleanup();


	}
